<%@ LANGUAGE="JSCRIPT" %> <%

// Contemplate Flattener (flattener.asp) version 1.1.1
// Copyright 1999-2005 Type A Learning Agency (http://www.typea.net)
// This file may be used, modified, or redistributed under the terms
// of the open-source agreement contained in docs/license.txt


	Server.ScriptTimeout = 300; // this is important for the flattener, since flattening a site can take several minutes

// this is a special JScript workaround for testing if an argument is set or not

	$undefined = Request.QueryString("alkdjfalkdjajdslkfjdalsjfdajljf");


// initialize variables that we might use before setting

	$flatten = 0;
	$input_file = "";
	$output_file = "";
	$stop = 0;
	$result = "";
	$output = "";
	$page_name = "";
	$pre_render_files = 1;
	$this_failure = 0;
	$changed = 0;
	$field_marker = "";
	$read_page_definitions_from = "";
	$unconvert_error = "";
	$changed_files = "";
	$check_URL = "";
	$settings_used = "";
	$template = "";
	$latest_mod_date = 0;


// define some useful functions
	
	function convert_URLs($text, $name) {
		// convert URLs like ../assembled/page.html
		$re = new RegExp($URL_rewriting_flag + "/", "ig");
		$text = $text.replace($re, "flattened/");
		
		// convert URLs like ../contemplate/assembler.asp?page=page
		$re = new RegExp("contemplate\/assembler\.asp\\?page\=([^<>\\s\'\"]+)([<>\\s\'\"])", "ig");
		$text = $text.replace($re, "flattened/" + "$1" + ".html" + "$2");
				
		// convert URLs like ../contemplate/assembler.asp?template=default&main=field,main,home
		$re = new RegExp("contemplate\/assembler\.asp\\?(template\=[^<>\\s\'\"]+)([<>\\s\'\"])", "ig");
		if ($re.test($text)) {
			$dynamic_page = RegExp.$1;
			$page_name = get_page_name($dynamic_page);
			if ($page_name != "") {
				$text = $text.replace($re, "flattened\/" + $page_name + "\.html" + "$2");
			} else {
				$result += "<font color=red>Error: Can't find a page name for " + $dynamic_page + " in " + $name + ".</font><br>";
			}
		}
		return $text;
	}

	function unconvert_URLs($text, $format_sample) {
		$flat_path = "../flattened/";
		$dynamic_path_short = "../" + $URL_rewriting_flag + "/";
		$dynamic_path_medium = "../contemplate/assembler.asp?page=";
		if (($format_sample.indexOf($dynamic_path_short) != -1)&&($format_sample.indexOf($dynamic_path_medium) != -1)) {
			$unconvert_error = "Error: Assembled page may only contain short or medium format dynamic URLs, not both<br>";
		} else {
			if ($format_sample.indexOf($dynamic_path_short) != -1) {
				// convert flattened URLs to ../assembled/page.html
				$re = new RegExp($flat_path, "ig");
				$text = $text.replace($re, $dynamic_path_short);
			} else if ($format_sample.indexOf($dynamic_path_medium) != -1) {
				// convert flattened URLs to ../contemplate/assembler.asp?page=page
				$re = new RegExp($flat_path + "([^<>\\s\'\"]+)\.html", "ig");
				$text = $text.replace($re, $dynamic_path_medium + "$1");
			}
		}
		return $text;
	}
	
	function get_file($file, $method, $check_last_modified) { // method can be "http", "filesystem", or "auto" (auto looks at $pre_render_files list)
		$text = "";
		$re11 = new RegExp("\/(\.\w.*)", "");
		$re12 = new RegExp("([^\\w-\.\/\?\&\=\%])", "");
		if ($re11.test($file)) { // don't read files whose names start with "."
			$text = show_error("Not authorized to read hidden file named \"" + RegExp.$1 + "\"");
		} else if ($re12.test($file)) { // don't read files whose names contain characters that could be used to read remote files, or to hack into the open command (Perl only)
			$text = show_error("File names can't contain the character " + RegExp.$1); // is there a way to return the whole matched expression, and remove the parentheses around the expression?
		} else {
			
			// first, figure out if we're going to read over HTTP or through the filesystem...
			if (($method == "")||($method == "auto")) {
				if ($pre_render_files) {
					for ($n=0; $n < $pre_render_files.length; $n++) {
						if ($file.indexOf($pre_render_files[$n]) != -1) { $method = "http"; }
					}
				}
			}

			// ...then get the file
			if ($method == "http") {

				// 1) prepare the URL for this type of connection
				$file_URL = absolute_path($file, "http");

				// 2) open a connection to the file
				XHO = Server.CreateObject("Microsoft.XMLHTTP");
				XHO.Open("GET", $file_URL, 0);
				$file_exists = 1; // to do: how can we test for this?
				if (! $file_exists) {
					$text = show_error("Can't open the file named \"" + $file + "\"" + $check_URL);
					$file_missing = 1;
				} else {
					XHO.Send();
					
					// 3) read the file
					$text = XHO.responseText;
	
					// 4) close the file connection
					XHO = "";
				}

				//$output .= "<p>reading " + $file_URL + " over http<p>";  // debug

			} else {

				// 1) prepare the URL for this type of connection
				$file_URL = absolute_path($file, "filesystem");
				
				// 2) open a connection to the file
				FSO = Server.CreateObject("Scripting.FileSystemObject");
				$file_exists = FSO.FileExists($file_URL);
				if (! $file_exists) {
					$text = show_error("Can't open the file named \"" + $file + "\"" + $check_URL);
					$file_missing = 1;
				} else {
				
					// 3) read the file
					$myfile = FSO.OpenTextFile($file_URL, 1);
					$text = $myfile.ReadAll();
					$file_missing = 0;
	
					// 4) for local files, catch the file's modification date (for $read_page_definitions_from and $template, plus content files when the template contains a env_last_modified tag)
					if ($check_last_modified) {
						$myfile2 = FSO.getFile($file_URL);
						$ASP_date = $myfile2.dateLastModified;
						$JScript_date = new Date($ASP_date);
						$mtime = $JScript_date.getTime();
						if ($mtime > $latest_mod_date) {
							$latest_mod_date = $mtime;
							$year = $JScript_date.getFullYear();
							$month = $JScript_date.getMonth() + 1; if ($month < 10) { $month = "0" + String($month); }
							$day = $JScript_date.getDate(); if ($day < 10) { $day = "0" + String($day); }
							$hour = $JScript_date.getHours();
							if ($hour < 12) {
								$ampm = "am";
							} else {
								$ampm = "pm";
								if ($hour > 12) {
									$hour = $hour - 12;
								}
							}
							//if ($hour < 10) { $hour = "0" + String($hour); }
							$minute = $JScript_date.getMinutes(); if ($minute < 10) { $minute = "0" + String($minute); }
							$latest_mod_date_formatted = $year + "-" + $month + "-" + $day + " - " + $hour + ":" + $minute + " " + $ampm;
						}
					}
			
					// 5a) close the file connection
					$myfile.Close();
					
				}

				// 5b) close the file connection
				FSO = "";

				//$output += "<p>reading " + $file_URL + " through filesystem<p>"; // debug
				
			}
							
			// finally, conform all line breaks to avoid cross-platform issues
			// we'd rather conform to Unix line breaks (\n), but that doesn't work in ASP, which doesn't support the s flag in regular expressions
			$text = $text.replace(/\r\n/g, "\r"); // change DOS to Mac
			$text = $text.replace(/\n/g, "\r"); // change Unix to Mac
			
		}
		return $text;
	}
	
	function get_setting($source_text, $setting, $allow_override, $allow_partial) {
		// allow most preferences to be overridden through the argument string
		$value = "";
		$setting_no_spaces = $setting;
		$setting_no_spaces = String($setting_no_spaces).replace(/[ -]/g, "_");
		$settings_used += $setting_no_spaces + ",";

		$override = (Request.QueryString($setting_no_spaces) != $undefined) ? Request.QueryString($setting_no_spaces) : "" ;
		if (($allow_override)&&($override != "")) {
			$value = $override;
			// don't allow users to pass code through the URL arguments
			$value = $value.replace(/\</, "&lt;");
			$value = $value.replace(/\>/, "&gt;");
		} else {
			$source_text = "\r" + $source_text; // this makes it easy to make sure settings start on a new line
			if ($allow_partial) {  // this lets us use more verbose labels in the ini file
				$re = new RegExp('[^\\w]' + $setting + '[^:\r]*: ([^\r]*)\r*', 'i');
				if ($re.test($source_text)) {
					$value = RegExp.$1;
				}
			} else {  // this ensures an exact match in the pages file
				$re = new RegExp('[^\\w]' + $setting + ': ([^\r]*)\r*', 'i');
				if ($re.test($source_text)) {
					$value = RegExp.$1;
				}
			}
		}
		if ($value == "0") { $value = 0; } // this ensures that a 0 value will evaluate false in every language
		return $value;
	}
	
    function get_page_name($page_definition, $source) { // look for a page definition that exactly matches a given dynamic URL
        $page_name = "";
        $source = "\r" + $source; // this makes it easier to match a page definition on the first line of the file
        $re = new RegExp('[^\\w]([-\\w]+)\:\\s+' + regex_quote($page_definition) + '[\&\s\r]', "");
        $page_name = ($re.test($source_text)) ? RegExp.$1 : "" ;
        return $page_name;
    }
	
	function get_page_names($source) { // return a list of all the page names in a page definitions file
		$page_names = Array();
		// in JScript, we could also set this up as a global match, then loop through the $matches array
		$re = new RegExp("([-\\w]+)\:\\s+[\\w]+", "");
		while ($re.test($source)) {
			$this_page_name = RegExp.$1;
			$page_names.push($this_page_name);
			$source = $source.replace($re, "");
		}
		return $page_names;
	}
	
	function get_directory_listing($directory) { // return a list of all the items in the specified directory
		$files = new Array();
		FSO = Server.CreateObject("Scripting.FileSystemObject")
		$dir = FSO.GetFolder(absolute_path($directory, "filesystem"));
		$dir_files = new Enumerator($dir.Files);
		if ($dir_files) {
			for (; !$dir_files.atEnd(); $dir_files.moveNext()) { // what the heck...
				$file = $dir_files.item().Name;
				if ($file.substr(0, 1) != ".") { $files.push($file); } // that gets files that don't start with a dot
			}
		}
		// in ASP, we have to do this once for files and once for folders
		$dir_folders = new Enumerator($dir.Subfolders);
		if ($dir_folders) {
			for (; !$dir_folders.atEnd(); $dir_folders.moveNext()) { // what the heck...
				$file = $dir_folders.item().Name;
				if ($file.substr(0, 1) != ".") { $files.push($file); } // that gets files that don't start with a dot
			}  
		}
		FSO = "";
		return $files;
	}

	function absolute_path($path, $method) { // convert a reference to a file within our site to an absolute URL
		if ($script_location) { // if this hasn't been set yet, just return the original value

			if ($method == "filesystem") {
			
				$path = Server.MapPath($path);
	
			} else {
			
				$thisserver = (Request.ServerVariables("HTTP_HOST") != $undefined) ? String(Request.ServerVariables("HTTP_HOST")) : "" ;
				$re = new RegExp("\/([^=]*\/)contemplate\/", "i");
				if ($re.test($request)) { $thispath = RegExp.$1; }
				$re = new RegExp("\/([^=]*\/)" + $URL_rewriting_flag + "\/", "i");
				if ($re.test($request)) { $thispath = RegExp.$1; }
				
				// pass along the authentication information if present
				$auth_info = (Request.ServerVariables("HTTP_AUTHORIZATION") != $undefined) ? String(Request.ServerVariables("HTTP_AUTHORIZATION")) : "" ;
				if (($auth_info)&&($auth_info.substr(0, 5) == "Basic")) {
					$auth_info = $auth_info.substr(5);
					$login = Base64Decode($auth_info);
					$login += "@";
				} else {
					$login = "";
				}
				
				$path = $path.replace("../", "http://" + $login + $thisserver + "/" + $thispath, ""); // replace the first updelim with the scheme and path
				$path = $path.replace("../", "", "g"); // remove additional updelims
			
			}
		
		}
		return $path;
	}

	function show_error($message) { // error display isn't as well developed here as in assembler, but we'll put this here so we can share more code
		return "Error: " + $message;
	}
	
%>

<script language="VBScript" runat="Server">

	' decode a base64-encoded string; this is a substitute for PHP's base64_decode() built-in function
	' http://www.webtutoriallist.com/list/finance.asp?url=http://www.pstruh.cz/tips/detpg_Base64.htm&name=Base64+decode+and+basic+authentication%20%20tutorial%20web%20page!

	Function Base64Decode(ByVal base64String)
	  'rfc1521
	  '1999 Antonin Foller, PSTRUH Software, http://pstruh.cz
	  Const Base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
	  Dim dataLength, sOut, groupBegin
	  
	  'remove white spaces, If any
	  base64String = Replace(base64String, vbCrLf, "")
	  base64String = Replace(base64String, vbTab, "")
	  base64String = Replace(base64String, " ", "")
	  
	  'The source must consists from groups with Len of 4 chars
	  dataLength = Len(base64String)
	  If dataLength Mod 4 <> 0 Then
		Err.Raise 1, "Base64Decode", "Bad Base64 string."
		Exit Function
	  End If
	
	  
	  ' Now decode each group:
	  For groupBegin = 1 To dataLength Step 4
		Dim numDataBytes, CharCounter, thisChar, thisData, nGroup, pOut
		' Each data group encodes up To 3 actual bytes.
		numDataBytes = 3
		nGroup = 0
	
		For CharCounter = 0 To 3
		  ' Convert each character into 6 bits of data, And add it To
		  ' an integer For temporary storage.  If a character is a '=', there
		  ' is one fewer data byte.  (There can only be a maximum of 2 '=' In
		  ' the whole string.)
	
		  thisChar = Mid(base64String, groupBegin + CharCounter, 1)
	
		  If thisChar = "=" Then
			numDataBytes = numDataBytes - 1
			thisData = 0
		  Else
			thisData = InStr(Base64, thisChar) - 1
		  End If
		  If thisData = -1 Then
			Err.Raise 2, "Base64Decode", "Bad character In Base64 string."
			Exit Function
		  End If
	
		  nGroup = 64 * nGroup + thisData
		Next
		
		'Hex splits the long To 6 groups with 4 bits
		nGroup = Hex(nGroup)
		
		'Add leading zeros
		nGroup = String(6 - Len(nGroup), "0") & nGroup
		
		'Convert the 3 byte hex integer (6 chars) To 3 characters
		pOut = Chr(CByte("&H" & Mid(nGroup, 1, 2))) + _
		  Chr(CByte("&H" & Mid(nGroup, 3, 2))) + _
		  Chr(CByte("&H" & Mid(nGroup, 5, 2)))
		
		'add numDataBytes characters To out string
		sOut = sOut & Left(pOut, numDataBytes)
	  Next
	
	  Base64Decode = sOut
	End Function

</script>

<%

// set up some primary variables

	$URL_rewriting_flag = "assembled"; // we'd rather store this in the preferences file, but we need it in order to read the preferences file!

	// figure out the location of the contemplate directory as shown in the browser, and use that as the basis for open commands;
	// this allows us to run the script from a symlink to the real contemplate folder, and paths will be relative to the
	// apparent, rather than the actual, location of assembler.asp
	// this will also prevent problems if Windows calculates relative paths from the server root
	$request = ((Request.ServerVariables("OS") != $undefined)&&(String(Request.ServerVariables("OS")).indexOf("Win") != -1)) ? String(Request.ServerVariables("SCRIPT_NAME")) : ( (String(Request.ServerVariables("REQUEST_URI")).indexOf("?") != -1) ? String(Request.ServerVariables("REQUEST_URI")).substr(0, String(Request.ServerVariables("REQUEST_URI")).indexOf("?")) : String(Request.ServerVariables("REQUEST_URI")) ) ;
	$script_location = (Request.ServerVariables("PATH_TRANSLATED") != $undefined) ? String(Request.ServerVariables("PATH_TRANSLATED")) : "" ;
	$script_location = $script_location.replace(/\\/g, "/");
	$re = new RegExp("(.*\/)" + $URL_rewriting_flag + "\/", "i");
	if ($re.test($script_location)) {
		$script_location = RegExp.$1 + "contemplate/";
	} else {
		$re = new RegExp("(.*\/)[^\/]+", "");
		if ($re.test($script_location)) { $script_location = RegExp.$1; }
	}
	
	$only = (Request.Form("only") != $undefined) ? String(Request.Form("only")) : "" ;
	$skip = (Request.Form("skip") != $undefined) ? String(Request.Form("skip")) : "" ;
	$mode = (Request.Form("mode") != $undefined) ? String(Request.Form("mode")) : "" ;
	$flatten = (Request.Form("flatten") != $undefined) ? String(Request.Form("flatten")) : "" ;
	$input_file = (Request.Form("input_file") != $undefined) ? String(Request.Form("input_file")) : "" ;
	$output_file = (Request.Form("output_file") != $undefined) ? String(Request.Form("output_file")) : "" ;
	
	$processed_count = 0;
	$skipped_count = 0;
	$error_count = 0;
	$changes = 0;


// read in a preferences (.ini) file if one exists

	$preferences = get_file("../data/preferences.ini", "filesystem", 0);
	if ($preferences) {
		$field_marker = get_setting($preferences, "field marker", 0, 1);
		//$URL_rewriting_flag = get_setting($preferences, "URL rewriting flag", 0, 1);
		$read_page_definitions_from = "../" + get_setting($preferences, "read page definitions from", 0, 1);
	} else {
		$field_marker = "";
		//$URL_rewriting_flag = "";
		$read_page_definitions_from = "";
	}
	
	
// do a bit of processing on the settings, and set some defaults in case preferences.ini or individual settings are absent

	if ($field_marker == "") { $field_marker = "##"; }

	//if ($URL_rewriting_flag == "") { $URL_rewriting_flag = "assembled"; }

	if ($read_page_definitions_from == "") { $read_page_definitions_from = "../data/pages.txt"; }
	

// set up the HTML page
	
	Response.write ("<html>\r");

	Response.write ("<head>\r");

	Response.write ("<title>Contemplate(tm) Web Templating System</title>\r");
	
	Response.write ("<link rel=stylesheet href=../stylesheet.css type=text/css>\r");

	Response.write ("</head>\r");

	Response.write ("<body bgcolor=#FFFFFF>\r");
	Response.write ("<p class=title>Contemplate</p>\r");
	Response.write ("<p class=body><a href=../index.html>Utilities menu</a> &gt; Flattener</p><br>\r");
	
	Response.write("<div class=body>\r");
	

// require a current version of the assembler before proceeding

	$required_version = 1.0; // we assume that any sub-sub-version will be compatible
	$extractor_text = get_file("../assembler.asp", "filesystem", 0);
	
	$matches = $extractor_text.match("version (\\d+\.\\d+)");
	if ($matches) {
		$installed_version = $matches[1];
	} else {
		$installed_version = 0;
	}
	if ($installed_version < $required_version) {
		Response.write("Error: This version of the Flattener requires version "+$required_version+" or newer of Contemplate (assembler.asp).<p>");
		$stop = 1;
	}
	

// present some options on the first run
	
	if ((!$flatten)&&(!$input_file)&&(!$stop)) {
	
	/////
	// show the intro page
	/////
			
		Response.write("<p class=subheading>Flatten assembled pages</p>\r");
		Response.write("<p class=body>Before you do this, create a folder called \"flattened\" at the root level of your website, and give it world-write access (chmod a+w flattened)</p>\r");
		
		Response.write("<form name=flatten method=post>\r");
		
		Response.write("<table><tr valign=bottom><td class=body>\r");
		
		Response.write("	Only names containing...<br>\r");
		Response.write("	<input type=text name=only size=32>\r");
		
		Response.write("</td><td class=body>\r");
		
		Response.write("	Skip names containing...<br>\r");
		Response.write("	<input type=text name=skip size=32>\r");
		
		Response.write("</td></tr></table><br>\r");
		
		Response.write("<p class=body>\r");
		Response.write("	<input type=radio name=mode value=flatten checked> Flatten only &nbsp;\r");
		Response.write("	<input type=radio name=mode value=preview> Preview only &nbsp;\r");
		Response.write("	<input type=radio name=mode value=both> Flatten and preview\r");
		Response.write("</p>\r");
				
		Response.write("<p class=body><input type=submit value=Flatten></p><br>\r");
		
		Response.write("<input type=hidden name=flatten value=1>\r");
		
		Response.write("</form>\r");
		
		Response.write("<p class=subheading>Convert links in a static page</p>\r");
		Response.write("<p class=body>If you have a static HTML page that contains links to assembled pages, this option will convert the links to use the flattened versions of those pages</p>\r");
		
		Response.write("<form name=parse method=post>\r");
		
		Response.write("<table><tr valign=bottom><td class=body>\r");
		
		Response.write("	Input file (e.g. index.html)<br>\r");
		Response.write("	<input type=text name=input_file size=32>\r");
		
		Response.write("</td><td class=body>\r");
		
		Response.write("	Output file (e.g. flattened/index.html)<br>\r");
		Response.write("	<input type=text name=output_file size=32>\r");
		
		Response.write("</td></tr></table><br>\r");
		
		Response.write("<p class=body><input type=submit value=Convert></p><br>\r");
		
		Response.write("</form>\r");
		

	} else {
	
	
	// grab the text of the pages.txt file; both options will use it
	
		$pages_file = get_file($read_page_definitions_from, "filesystem", 0);
		if ($file_missing) { Response.write($pages_file + "<p>"); } // the result of get_file will contain the error message
		
	
		if (($flatten)&&(!$file_missing)) {
		
		////
		// flatten assembled pages
		////
		
			// parse the pages file to get an array of page names and an array of URLs
			
				$pages = new Array(); $URLs = new Array();
				$page_names = get_page_names($pages_file);
				for ($i=0; $i<$page_names.length; $i++) {
					$this_page_name = $page_names[$i];
					$this_page = "../flattened/" + $this_page_name + ".html";
					$this_URL = "../contemplate/assembler.asp?page=" + $this_page_name + "&skip_rendering=1";
					$pages[$i] = $this_page;
					$URLs[$i] = $this_URL;
				}
				
				
			// open each URL, change its dynamic links to static ones, and save it to its page name
			
				$verb_present = ($mode == "preview") ? "Previewing" : "Flattening" ;
				$verb_past = ($mode == "preview") ? "Previewed" : "Flattened" ;

				for ($i=0; $i<$pages.length; $i++) {
				
					// skip some pages if the user put something into the filter fields
					if (($only)&&($pages[$i].indexOf($only) == -1)) {
						$result += "Skipping " + $pages[$i] + "<br>";
						$skipped_count++;
					} else if (($skip)&&($pages[$i].indexOf($skip) != -1)) {
						$result += "Skipping " + $pages[$i] + "<br>";
						$skipped_count++;
					} else {
						$processed_count++;

						// get the dynamic page
						$file_missing = 0;
						$page_rendered = get_file("../" + $URLs[$i], "http", 0);
	
						if ($file_missing) {
							$result += "<font color=red>" + $page_rendered + "</font><br>"; // that will contain the error if $file_missing == 1
							$error_count++;
						} else {
						
							// convert all the dynamic URLs to flattened ones
							$page_rendered = convert_URLs($page_rendered, $pages[$i]);
											
							// if a flatten is requested, save the flattened HTML
							if (($mode == "flatten")||($mode == "both")) {
								FSO = Server.CreateObject("Scripting.FileSystemObject");
								$unicode = ($page_rendered.indexOf("charset=utf-8") != -1);
								$my_file = FSO.CreateTextFile(absolute_path("../" + $pages[$i], "filesystem"), true, $unicode);
								if ((FSO)&&($my_file)) {
									$my_file.Write($page_rendered);
									$result += $verb_present + " " + $pages[$i] + "<br>";
								} else {
									$result += "<font color=red>Error: Can't open the file " + $pages[$i] + " for flattening.</font><br>";
									$error_count++;
								}
							}
							
							// if a preview is requested, show the flattened page
							if (($mode == "preview")||($mode == "both")) {
								$re = new RegExp("<body[^>]*>(.*)<\/body>", "i");
								if ($re.test($page_rendered)) {
									$page_preview = RegExp.$1;
									$page_preview = $page_preview.replace(/([^\/])\.\.\//g, "$1../../"); // add another level to relative paths so that graphics and links still work
									if (($mode == "preview")||(!$my_file)) {
										// if we didn't show a flatten label, or flattening failed, show a preview label
										$result += "Previewing " + $pages[$i] + "<br>";
									}
									$result += "<table border=1><tr><td>" + $page_preview + "</td></table><br>";
								} else {
									$result += "Error: Can't display a preview for the file " + $pages[$i] + "<br>";
									$error_count++;
								}
							}
						
							$my_file = "";
							FSO = "";
							
						}
					
					}

					// provide feedback as the script runs
					Response.write($result);
					$result = "";
				
				}
		
			// show success rate and, if errors, offer tips
		
				Response.write("<br><b>Processed " + $processed_count + " files, skipped " + $skipped_count + " files, and encountered " + $error_count + " errors</b><p>\r");
		
	
		} else if ($input_file) {
	
		/////
		// convert links in a static page
		////
		
			// open the file, change its dynamic links to static ones, and save it to its output location
			
				// in case the paths aren't relative to the contemplate folder
				$input_file = ($input_file.indexOf("../") != -1) ? $input_file : "../" + $input_file ;
				$output_file = ($output_file.indexOf("../") != -1) ? $output_file : "../" + $output_file ;
				
				// get the file
				$delimiter = ($input_file.indexOf("?") == -1) ? "?" : "&" ;
				$file = get_file("../" + $input_file + $delimiter + "skip_rendering=1", "http", 0);

				// convert all the dynamic URLs to flattened ones
				$file = convert_URLs($file, $input_file);
			
				// save the parsed file
				FSO = Server.CreateObject("Scripting.FileSystemObject");
				$unicode = ($file.indexOf("charset=utf-8") != -1);
				$my_file = FSO.CreateTextFile(absolute_path("../" + $output_file, "filesystem"), true, $unicode);
				if ((! FSO)||(! $my_file)) {
					$error_count++;
				} else {
					$my_file.Write($file);
				}
				$my_file = "";
				FSO = "";

			// show result
		
				if (!$error_count) {
					Response.write("<b>Converted " + $input_file + " successfully</b><p>");
				} else {
					Response.write("Error: Couldn't open the file " + $output_file + " for saving.<br>");
					Response.write("<b>Failed to convert " + $input_file + "</b><p>");
				}
				
		
		}
	
		if (!$stop) {
			Response.write("<p class=body><a href=JavaScript:history.back()>Back</a></p>");
		}
				
		Response.write($output); // we don't use the $output variable in this script, but this helps us share code with assembler.asp
				

// finish off a big conditional up there

	}	
	
	
// we're done!

	Response.write("</div>");

	Response.write("</body></html>");

%>
